//
//  Avator.h
//  SampleApp
//
//  Created by Hiroki Azumada on 2014/06/08.
//
//

#ifndef __SampleApp__Avator__
#define __SampleApp__Avator__

#include "cocos2d.h"
#include "SbdPlayer.h"

class Avator : public cocos2d::CCObject
{
public:
	enum Action
	{
		Action_Stop,
		Action_Walk,
	};

	static Avator* create(const cocos2d::CCRect& movabled, const cocos2d::CCPoint& startPosition);

	void setFigure(sbd::Player* figure);
	
	void setDirection(int direction);
	
	void setSpeed(float speed) { _speed = speed; }

	void update(float dt);

	const cocos2d::CCPoint& getPosition() const
	{
		return _position;
	}


private:
	Avator();

	cocos2d::CCPoint	_position;
	cocos2d::CCRect	_movabled;
	Action			_action;
	int				_actionTime;
	int				_direction;			// degree
	float			_speed;
	int				_actionDelay;
	sbd::Player*	_figure;
};

#endif /* defined(__SampleApp__Avator__) */
