//
//  MainScene.h
//  SampleApp
//
//  Created by Hiroki Azumada on 2014/06/08.
//
//

#ifndef __SampleApp__MainScene__
#define __SampleApp__MainScene__

#include "cocos2d.h"
#include "SbdPlayer.h"
#include "Utils.h"


class GameState
{
public:
	enum Mode
	{
		Mode_SingleChar,
		Mode_SingleTexture,
		Mode_MultiTextures,
	};
	
	enum TextureFormat
	{
		TF_PVRTC,
		TF_PNG,
	};
	
	static Mode				mode;
	static bool				isRandomScale;
	static TextureFormat	textureFormat;
	static bool				useSpriteBatchNode;
};



class Main : public cocos2d::CCLayerGradient
{
public:
	enum Clothes
	{
		Clothes_None,
		Clothes_Glass,
		Clothes_GlassAndWear,
		Clothes_GlassAndWearAndHat,
		Clothes_NumClothes
	};

    static cocos2d::CCScene* createScene();

    virtual bool init();
	virtual void onEnter();
    
	void initContents();

	void update(float dt);

    // a selector callback
    void menuCloseCallback(CCObject* pSender);
    void menuPlusAvatorCallback(CCObject* pSender);
    void menuPlus10AvatorCallback(CCObject* pSender);
    void menuMinusAvatorCallback(CCObject* pSender);
    void menuMinus10AvatorCallback(CCObject* pSender);
    void menuWearCallback(CCObject* pSender);

	void createAvator();
	void removeAvator();
	
	void changeClothes(sbd::Player* player, Clothes clothes);
	
    // implement the "static create()" method manually
    CREATE_FUNC(Main);

private:
	void updateCountLabel();

	cocos2d::CCNode*		_playfield;
	cocos2d::CCSpriteBatchNode*	__playfieldBN;
	Clothes					_clothes;

	cocos2d::CCLabelTTF*	_countLabel;
	std::string				_countString;

	FRandom					_rand1;
	FRandom					_rand2;
};

#endif /* defined(__SampleApp__MainScene__) */
