//
//  MainScene.h
//  SampleApp
//
//  Created by Hiroki Azumada on 2014/06/08.
//
//

#ifndef __SampleApp__MainScene__
#define __SampleApp__MainScene__

#include "cocos2d.h"
#include "SbdPlayer.h"
#include "Utils.h"


class GameState
{
public:
	enum class Mode
	{
		SingleChar,
		SingleTexture,
		MultiTextures,
	};
	
	enum class TextureFormat
	{
		PVRTC,
		PNG,
	};
	
	static Mode				mode;
	static bool				isRandomScale;
	static TextureFormat	textureFormat;
	static bool				useSpriteBatchNode;
};



class Main : public cocos2d::LayerGradient
{
public:
	enum class Clothes
	{
		None,
		Glass,
		GlassAndWear,
		GlassAndWearAndHat,
		NumClothes
	};
	
    static cocos2d::Scene* createScene();

    virtual bool init();
	virtual void onEnter();
    
	void initContents();

	void update(float dt);

    // a selector callback
    void menuCloseCallback(cocos2d::Ref* pSender);
    void menuPlusAvatorCallback(cocos2d::Ref* pSender);
    void menuPlus10AvatorCallback(cocos2d::Ref* pSender);
    void menuMinusAvatorCallback(cocos2d::Ref* pSender);
    void menuMinus10AvatorCallback(cocos2d::Ref* pSender);
    void menuWearCallback(cocos2d::Ref* pSender);

	void createAvator();
	void removeAvator();
	
	void changeClothes(sbd::Player* player, Clothes clothes);
	
    // implement the "static create()" method manually
    CREATE_FUNC(Main);

private:
	void updateCountLabel();

	cocos2d::Node*		_playfield;
	Clothes				_clothes;

	cocos2d::LabelTTF*	_countLabel;
	std::string			_countString;

	FRandom				_rand1;
	FRandom				_rand2;
};

#endif /* defined(__SampleApp__MainScene__) */
