//
//  TitleScene.h
//  SampleApp
//
//  Created by Hiroki Azumada on 2014/06/08.
//
//

#ifndef __SampleApp__TitleScene__
#define __SampleApp__TitleScene__

#include "cocos2d.h"
#include "MainScene.h"

class Title : public cocos2d::Layer
{
public:
    // there's no 'id' in cpp, so we recommend returning the class instance pointer
    static cocos2d::Scene* createScene();

    // Here's a difference. Method 'init' in cocos2d-x returns bool, instead of returning 'id' in cocos2d-iphone
    virtual bool init();  
    
    // a selector callback
    void menuCloseCallback(cocos2d::Ref* pSender);
    void menuStartCallback(cocos2d::Ref* pSender);
    void menuStartWithBatchCallback(cocos2d::Ref* pSender);
    void menuStart2Callback(cocos2d::Ref* pSender);
    void menuStart2WithBatchCallback(cocos2d::Ref* pSender);
    void menuStart3Callback(cocos2d::Ref* pSender);
    void menuTextureFormatToggleCallback(cocos2d::Ref* pSender);
    void menuRandomScaleToggleCallback(cocos2d::Ref* pSender);
    
	void changeScene(GameState::Mode mode, bool useSpriteBatchNode = false);
	void createMenuItem(cocos2d::Vector<cocos2d::MenuItem*>& buttons, const cocos2d::Vec2& pos, const std::string& label, const cocos2d::ccMenuCallback& callback);
	cocos2d::Menu* createToggleButton(const std::string& offTexName, const std::string& onTexName, const cocos2d::ccMenuCallback& callback, unsigned int initialIndex);

    // implement the "static create()" method manually
    CREATE_FUNC(Title);
};

#endif /* defined(__SampleApp__TitleScene__) */
