﻿using UnityEngine;
using System.Collections;

public class SpriteCreatorMany : MonoBehaviour {

	public	bool InstantiatePrefabs = false;

	public GameObject[]	prefabs = new GameObject[16];
	public	Texture2D[] textures = new Texture2D[16];
	Sprite[] sprites = new Sprite[16];

	void Awake(){
		Camera.main.orthographicSize = Screen.height / 2;

		for (int i = 0; i < textures.Length; ++i)
		{
			sprites[i] = Sprite.Create(textures[i], new Rect(0,0,textures[i].width, textures[i].height), new Vector2(0.5f,0.5f), 1);
		}
	}

	// Use this for initialization
	void Start () {
	}
	
	// Update is called once per frame
	void Update () {
		if (Application.platform == RuntimePlatform.Android && Input.GetKey(KeyCode.Escape)){
			Application.Quit();
		}
		// タッチされたとき
		if (Input.GetMouseButtonDown(0)) {
			if(Input.mousePosition.y >= Screen.height /2 ){
				if(Input.mousePosition.x <= Screen.width /2){
					AddSprite();
				}else{
					AddSprite(10);
				}
			}else{
				for(int i=0;i<SpriteCount; i++){
					Object[] sprites = GameObject.FindGameObjectsWithTag("Respawn");
					foreach (var e in sprites)
						Destroy(e);
				}
				SpriteCount=0;
				AddSprite(powCounter);
				powCounter *= 2;
			}
		}
		/*
		Touch touch = Input.GetTouch (0);
		// タッチされたとき
		if (touch.phase == TouchPhase.Began) {
			if(touch.position.y >= Screen.height /2 ){
				if(touch.position.x <= Screen.width /2){
					AddSprite();
				}else{
					AddSprite(10);
				}
			}else{
				for(int i=0;i<SpriteCount; i++){
					GameObject clone = GameObject.Find(("Sprite"+i+"(Clone)"));
					Destroy(clone);
				}
				SpriteCount=0;
				AddSprite(powCounter);
				powCounter *= 2;
			}
		}
		*/
	}
	
	void AddSprite(){
		float x = Random.Range (-Screen.width / 2, Screen.width / 2);
		float y = Random.Range (-Screen.height / 2, Screen.height / 2);

		int index = (SpriteCount % 16) + 1;

		GameObject go;
		if (InstantiatePrefabs)
		{
			go = Instantiate(prefabs[index - 1]) as GameObject;
		}else{
			go = new GameObject("Sprite" + SpriteCount);
			go.AddComponent<SpriteRenderer>().sprite = sprites[index - 1];
			go.tag = "Respawn";
		}
		go.transform.position = new Vector3(x, y, 0);
		go.GetComponent<SpriteRenderer>().sprite = sprites[index - 1];

		SpriteCount++;
	}
	void AddSprite(int num){
		for (int i=0; i<num; i++) {
			AddSprite ();
		}
	}

	private static int SpriteCount = 0;
	public static int GetSpriteCount {
		get { return SpriteCount; }
	}
	private int powCounter = 10;
}
