﻿using UnityEngine;
using System.Collections;

public class SpriteCreator : MonoBehaviour {

	public Texture2D	texture;	
	Sprite	sprite;

	void Awake() {
		Camera.main.orthographicSize = Screen.height / 2;
		sprite = Sprite.Create(texture, new Rect(0,0,texture.width, texture.height), new Vector2(0.5f,0.5f), 1);
	}

	// Use this for initialization
	void Start () {
	}
	
	// Update is called once per frame
	void Update () {
		if (Application.platform == RuntimePlatform.Android && Input.GetKey(KeyCode.Escape)){
			Application.Quit();
		}
		// タッチされたとき
		if (Input.GetMouseButtonDown(0)) {
			if(Input.mousePosition.y >= Screen.height /2 ){
				if(Input.mousePosition.x <= Screen.width /2){
					AddSprite();
				}else{
					AddSprite(10);
				}
			}else{
				for(int i=0;i<SpriteCount; i++){
					GameObject clone = GameObject.Find(("Sprite"+i+"(Clone)"));
					Destroy(clone);
				}
				SpriteCount=0;
				AddSprite(powCounter);
				powCounter *= 2;
			}
		}
		/*
		Touch touch = Input.GetTouch (0);
		// タッチされたとき
		if (touch.phase == TouchPhase.Began) {
			if(touch.position.y >= Screen.height /2 ){
				if(touch.position.x <= Screen.width /2){
					AddSprite();
				}else{
					AddSprite(10);
				}
			}else{
				for(int i=0;i<SpriteCount; i++){
					GameObject clone = GameObject.Find(("Sprite"+i+"(Clone)"));
					Destroy(clone);
				}
				SpriteCount=0;
				AddSprite(powCounter);
				powCounter *= 2;
			}
		}
		*/
	}
	
	void AddSprite(){
		float x = Random.Range (-Screen.width / 2, Screen.width / 2);
		float y = Random.Range (-Screen.height / 2, Screen.height / 2);

		Prefab.name = "Sprite" + SpriteCount;

		GameObject clone = Instantiate (Prefab, new Vector3 (x, y, 0), Quaternion.identity) as GameObject;
		var renderer = clone.GetComponent<SpriteRenderer>();
		renderer.sprite = sprite;
		SpriteCount++;
	}
	void AddSprite(int num){
		for (int i=0; i<num; i++) {
			AddSprite ();
		}
	}


	public GameObject Prefab;
	private static int SpriteCount = 0;
	public static int GetSpriteCount {
		get { return SpriteCount; }
	}
	private int powCounter = 10;
}
