﻿using UnityEngine;
//using System;
using System.Collections;

public class Avatar : MonoBehaviour {


	private Vector3 _position;
	private Rect _movabled;
	private int _direction;	//degree
	private int _actionDelay;


	public Avatar()
	{
		speed = 1.0f;
	}


	void Start () {
		float width = Screen.width;
		float height = Screen.height;
		_movabled = new Rect(-width / 2, -height / 2, width, height);
	}


	public void Initialize(Rect movabled, Vector2 startPosition)
	{
//		_movabled = movabled;
	}


	public float speed { get; set; }
	
	public int direction
	{
		get { return _direction; }
		set
		{
			_direction = value;

			var flipX = _direction < 180;
			var scale = this.transform.localScale;
			float scaleX = Mathf.Abs(scale.x);
			if (flipX) scaleX *= -1;

			this.transform.localScale = new Vector3(scaleX, scale.y, scale.z);
		}
	}


	void Update () {

		float dt = Time.deltaTime;

		int dir = (_direction + 270) % 360;
		float r = (float)dir * ((float)Mathf.PI / 180.0f);
		float x = (float) Mathf.Cos(r);
		float y = (float) -Mathf.Sin(r);
		
		float s = dt / (1.0f / 60.0f);
		s *= speed;
		x *= s;
		y *= s;

		_position.x += x;
		_position.y += y;

		if (_actionDelay <= 0)
		{
			if (!_movabled.Contains(new Vector2(_position.x, _position.y)))
			{
				int newDir = (_direction + 100) % 360;
				direction = newDir;
				_actionDelay = 10;
			}
		}
		else
		{
			_actionDelay--;
		}
		
//		this.transform.position = new Vector3(_position.x / 100, _position.y / 100, _position.y / 1000);
		this.transform.position = new Vector3(_position.x, _position.y, _position.y / 1000);
	}
}
