﻿using UnityEngine;
using System.Collections;

public class TitleScript : MonoBehaviour {

	public GUIStyle startButton = new GUIStyle();
	public GUIStyle closeButton = new GUIStyle();
	public GUIStyleState styleState = new GUIStyleState();
	public GUIStyle textStyle = new GUIStyle();

	void Start ()
	{
		textStyle.fontSize = 24;
		styleState.textColor = Color.white;
		textStyle.normal = styleState;

		startButton.alignment = TextAnchor.MiddleCenter;
		startButton.fontSize = 24;
		startButton.normal.background = Resources.Load("Buttons/start") as Texture2D;
		startButton.normal.textColor = Color.white;
		startButton.active.background = Resources.Load("Buttons/startClicked") as Texture2D;
		startButton.active.textColor = Color.white;

		closeButton.normal.background = Resources.Load("Buttons/close") as Texture2D;
		closeButton.active.background = Resources.Load("Buttons/close_p") as Texture2D;
	}


	void Update ()
	{
	}


	void OnGUI ()
	{
		float centerX = Screen.width / 2;
		float centerY = Screen.height / 2;

		var width = startButton.normal.background.width * 2;
		var height = startButton.normal.background.height * 2;

		float buttonX = centerX - width / 2;
		float buttonY = centerY - height / 2;

		if (GUI.Button(new Rect(buttonX, buttonY - 130, width, height), "1 Tex", startButton))
		{
			SoundScript.Instance().PlayOneShot(SoundScript.Instance().clip);
			GameState.mode = GameState.Mode.SingleChar;
			Application.LoadLevel("Main");
		}
		
		if (GUI.Button(new Rect(buttonX, buttonY + 0, width, height), "2 Tex", startButton))
		{
			SoundScript.Instance().PlayOneShot(SoundScript.Instance().clip);
			GameState.mode = GameState.Mode.SingleTexture;
			Application.LoadLevel("Main");
		}
	
		if (GUI.Button(new Rect(buttonX, buttonY + 130, width, height), "8 Tex", startButton))
		{
			SoundScript.Instance().PlayOneShot(SoundScript.Instance().clip);
			GameState.mode = GameState.Mode.MultiTextures;
			Application.LoadLevel("Main");
		}


		bool usePng = GameState.textureFormat == GameState.TextureFormat.PNG;
		usePng = GUI.Toggle(new Rect(centerX + 200, centerY, 100, 50), usePng, "PNG");
		GameState.textureFormat = usePng ? GameState.TextureFormat.PNG : GameState.TextureFormat.PVRTC;

		GameState.withRandomScale =
			GUI.Toggle(new Rect(centerX + 200, centerY + 100, 100, 50), GameState.withRandomScale, "Random Scale");


		var closeWidth = closeButton.normal.background.width;
		var closeHeight = closeButton.normal.background.height;

		if (GUI.Button(new Rect(Screen.width - closeWidth, Screen.height - closeHeight, closeWidth, closeHeight), "", closeButton))
		{
			Application.Quit();
		}
	}

}
